import pygame
import random

from infobox import InfoBox
from cursor import Cursor
from level import LevelSet

class Game:
    def __init__(self):
        self.board = None
        self.infobox = InfoBox(self)

        self.levels = LevelSet("data/default.xml")
        self.levels.setupGame(self)

        self.cursor = Cursor()
        self.score = 0
        self.total_score = 0
        self.lives = 5

    def update(self, time):
        self.board.update(time)
        self.infobox.update(time)
        self.cursor.update(time)

    def render(self, screen):
        self.infobox.render(screen)
        self.board.render(screen)
        self.cursor.render(screen)

    def click(self, pos, button):
        return self.board.click(pos, button) or self.infobox.click(pos, button)
