import pygame

import main

class Intro:
    def __init__(self):
        self.bigfont = pygame.font.Font(pygame.font.match_font("Arial"), 80)
        self.smallfont = pygame.font.Font(pygame.font.match_font("Arial"), 40)
        self.level = self.bigfont.render("Level %i" % (main.gm.levels.currentlevel+1), True, (0, 0, 0))
        self.levelrect = self.level.get_rect()
        self.levelrect.topleft = (400 - self.levelrect.width/2, 75)

        msg = "To complete this level you must supply"
        self.msg = self.smallfont.render(msg, True, (0, 0, 0))
        self.msgrect = self.msg.get_rect()
        self.msgrect.topleft = (400 - self.msgrect.width/2, 200)
        self.targetmsg = {}
        targets = main.gm.levels.levels[main.gm.levels.currentlevel]["targets"][0]
        y = 250
        if targets.has_key("O"):
            msg = self.smallfont.render("%i units of plain steam" % (targets["O"], ), True, (0, 0, 0))
            rect = msg.get_rect()
            rect.topleft = (400 - rect.width/2, y)
            y += 50
            self.targetmsg["O"] = msg, rect
        if targets.has_key("R"):
            msg = self.smallfont.render("%i units of red steam" % (targets["R"], ), True, (0, 0, 0))
            rect = msg.get_rect()
            rect.topleft = (400 - rect.width/2, y)
            y += 50
            self.targetmsg["R"] = msg, rect
        if targets.has_key("G"):
            msg = self.smallfont.render("%i units of green steam" % (targets["G"], ), True, (0, 0, 0))
            rect = msg.get_rect()
            rect.topleft = (400 - rect.width/2, y)
            y += 50
            self.targetmsg["G"] = msg, rect
        if targets.has_key("B"):
            msg = self.smallfont.render("%i units of blue steam" % (targets["B"], ), True, (0, 0, 0))
            rect = msg.get_rect()
            rect.topleft = (400 - rect.width/2, y)
            y += 50
            self.targetmsg["B"] = msg, rect
        if targets.has_key("Y"):
            msg = self.smallfont.render("%i units of yellow steam" % (targets["Y"], ), True, (0, 0, 0))
            rect = msg.get_rect()
            rect.topleft = (400 - rect.width/2, y)
            y += 50
            self.targetmsg["Y"] = msg, rect

        self.pressure = self.smallfont.render("at between %i and %i psi." % (targets["min"], targets["max"]), True, (0, 0, 0))
        self.pressurerect = self.pressure.get_rect()
        self.pressurerect.topleft = (400 - self.pressurerect.width/2, y)

        self.clickmsg = self.smallfont.render("Click To Continue", True, (255, 255, 255))
        self.clickmsgrect = self.clickmsg.get_rect()
        self.clickmsgrect.topleft = (400 - self.clickmsgrect.width/2, 500)

    def update(self, time):
        pass

    def render(self, screen):
        screen.blit(self.level, self.levelrect)
        screen.blit(self.msg, self.msgrect)
        for k in ["O", "R", "G", "B", "Y"]:
            if self.targetmsg.has_key(k):
                screen.blit(self.targetmsg[k][0], self.targetmsg[k][1])
        screen.blit(self.pressure, self.pressurerect)
        screen.blit(self.clickmsg, self.clickmsgrect)

    def click(self, pos, button):
        if button == 1 :
            main.state = main.PLAY
