import pygame

import main
from gfx import loadImage
from game import Game

class Menu:
    def __init__(self):
        self.logo = loadImage("logo.png")
        self.logorect = self.logo.get_rect()
        self.logorect.topleft = (400 - self.logorect.width/2, 50)
        self.by = loadImage("byandrew.png")
        self.byrect = self.by.get_rect()
        self.byrect.topleft = (610 - self.byrect.width/2, 525)
        self.play = loadImage("menu_play.png")
        self.playrect = self.play.get_rect()
        self.playrect.topleft = (400 - self.playrect.width/2, 300)
        self.instructions = loadImage("menu_instructions.png")
        self.instructionsrect = self.instructions.get_rect()
        self.instructionsrect.topleft = (400 - self.instructionsrect.width/2, 350)
        #self.highscores = loadImage("menu_highscores.png")
        #self.highscoresrect = self.highscores.get_rect()
        #self.highscoresrect.topleft = (400 - self.highscoresrect.width/2, 400)
        self.quit = loadImage("menu_quit.png")
        self.quitrect = self.quit.get_rect()
        self.quitrect.topleft = (400 - self.quitrect.width/2, 450)

    def update(self, time):
        pass

    def render(self, screen):
        screen.blit(self.logo, self.logorect)
        screen.blit(self.by, self.byrect)
        screen.blit(self.play, self.playrect)
        screen.blit(self.instructions, self.instructionsrect)
        #screen.blit(self.highscores, self.highscoresrect)
        screen.blit(self.quit, self.quitrect)

    def click(self, pos, button):
        if button != 1:
            return False
        if self.playrect.collidepoint(pos):
            main.gm = Game()
            main.state = main.BEGIN_GAME
            return True
        elif self.instructionsrect.collidepoint(pos):
            main.state = main.INSTRUCTIONS
            return True
        #elif self.highscoresrect.collidepoint(pos):
        #    main.state = main.BEGIN_GAME
        #    return True
        elif self.quitrect.collidepoint(pos):
            pygame.event.post(pygame.event.Event(pygame.QUIT))
            return True
        else:
            return False
