import random

from pipedreams.gfx import loadImage
from piece import Piece

class Boiler(Piece):
    def __init__(self):
        Piece.__init__(self)

        self.image = loadImage("boiler.png")

        self.no_graph = True
        self.rate = 0.0

        self.accept = []
        self.volume = 1


    def update(self, time):
        if self.right and Piece.LEFT in self.right.accept:
            size = random.randint(1, 100)
            if random.random() < self.rate:
                #print "boiler injecting %i left" % (size, )
                from pipedreams.main import gm
                gm.board.smoke.addSmoke(self.rect.topleft[0] + 16, self.rect.topleft[1] + 10)
                gm.board.smoke.addSmoke(self.rect.topleft[0] + 16, self.rect.topleft[1] + 10)
                gm.score -= 1
                self.right.acceptSteam({"O": size})

    def render(self, screen):
        screen.blit(self.image, self.rect)

    def increaseRate(self):
        self.rate += 0.1
        if self.rate > 1.0:
            self.rate = 1.0

    def decreaseRate(self):
        self.rate -= 0.1
        if self.rate < 0.0:
            self.rate = 0.0
