from pipedreams.gfx import loadImage

from piece import Piece

limit = 30.0

class CompressorRight(Piece):
    def __init__(self):
        Piece.__init__(self)

        self.image = loadImage("compressor_right.png")
        self.accept = [Piece.LEFT]
        self.pipe = True
        self.no_graph = True
        self.volume = 10
        self.rotate = CompressorDown

    def update(self, time):
        Piece.update(self, time)
        if self.pressure > 1 and self.right and Piece.LEFT in self.right.accept:
            steam = float(self.steam)
            size = min(limit, self.steam)
            self.right.acceptSteam({"O": self.O*(size/steam),
                               "R": self.R*(size/steam),
                               "G": self.G*(size/steam),
                               "B": self.B*(size/steam),
                               "Y": self.Y*(size/steam)})
            self.releaseSteam(size)

class CompressorDown(Piece):
    def __init__(self):
        Piece.__init__(self)

        self.image = loadImage("compressor_down.png")
        self.accept = [Piece.UP]
        self.pipe = True
        self.no_graph = True
        self.volume = 10
        self.rotate = CompressorLeft

    def update(self, time):
        Piece.update(self, time)
        if self.pressure > 1 and self.down and Piece.UP in self.down.accept:
            steam = float(self.steam)
            size = min(limit, self.steam)
            self.down.acceptSteam({"O": self.O*(size/steam),
                               "R": self.R*(size/steam),
                               "G": self.G*(size/steam),
                               "B": self.B*(size/steam),
                               "Y": self.Y*(size/steam)})
            self.releaseSteam(size)

class CompressorLeft(Piece):
    def __init__(self):
        Piece.__init__(self)

        self.image = loadImage("compressor_left.png")
        self.accept = [Piece.RIGHT]
        self.pipe = True
        self.no_graph = True
        self.volume = 10
        self.rotate = CompressorUp

    def update(self, time):
        Piece.update(self, time)
        if self.pressure > 1 and self.left and Piece.RIGHT in self.left.accept:
            steam = float(self.steam)
            size = min(limit, self.steam)
            self.left.acceptSteam({"O": self.O*(size/steam),
                               "R": self.R*(size/steam),
                               "G": self.G*(size/steam),
                               "B": self.B*(size/steam),
                               "Y": self.Y*(size/steam)})
            self.releaseSteam(size)

class CompressorUp(Piece):
    def __init__(self):
        Piece.__init__(self)

        self.image = loadImage("compressor_up.png")
        self.accept = [Piece.DOWN]
        self.pipe = True
        self.no_graph = True
        self.volume = 10
        self.rotate = CompressorRight

    def update(self, time):
        Piece.update(self, time)
        if self.pressure > 1 and self.up and Piece.DOWN in self.up.accept:
            steam = float(self.steam)
            size = min(limit, self.steam)
            self.up.acceptSteam({"O": self.O*(size/steam),
                               "R": self.R*(size/steam),
                               "G": self.G*(size/steam),
                               "B": self.B*(size/steam),
                               "Y": self.Y*(size/steam)})
            self.releaseSteam(size)
