from pipedreams.gfx import loadImage

from piece import Piece

class Corner1(Piece):
    def __init__(self):
        Piece.__init__(self)

        self.image = loadImage("corner1.png")
        self.accept = [Piece.LEFT, Piece.UP]
        self.pipe = True
        self.volume = 10
        self.rotate = Corner2

    def update(self, time):
        Piece.update(self, time)
        if self.pressure > 1 and self.left and Piece.RIGHT in self.left.accept:
            self.transferSteam(self.left)
        if self.pressure > 1 and self.up and Piece.DOWN in self.up.accept:
            old = self.steam
            self.transferSteam(self.up)

class Corner2(Piece):
    def __init__(self):
        Piece.__init__(self)

        self.image = loadImage("corner2.png")
        self.accept = [Piece.UP, Piece.RIGHT]
        self.pipe = True
        self.volume = 10
        self.rotate = Corner3

    def update(self, time):
        Piece.update(self, time)
        if self.pressure > 1 and self.up and Piece.DOWN in self.up.accept:
            self.transferSteam(self.up)
        if self.pressure > 1 and self.right and Piece.LEFT in self.right.accept:
            self.transferSteam(self.right)

class Corner3(Piece):
    def __init__(self):
        Piece.__init__(self)

        self.image = loadImage("corner3.png")
        self.accept = [Piece.RIGHT, Piece.DOWN]
        self.pipe = True
        self.volume = 10
        self.rotate = Corner4

    def update(self, time):
        Piece.update(self, time)
        if self.pressure > 1 and self.right and Piece.LEFT in self.right.accept:
            self.transferSteam(self.right)
        if self.pressure > 1 and self.down and Piece.UP in self.down.accept:
            self.transferSteam(self.down)

class Corner4(Piece):
    def __init__(self):
        Piece.__init__(self)

        self.image = loadImage("corner4.png")
        self.accept = [Piece.DOWN, Piece.LEFT]
        self.pipe = True
        self.volume = 10
        self.rotate = Corner1

    def update(self, time):
        Piece.update(self, time)
        if self.pressure > 1 and self.down and Piece.UP in self.down.accept:
            self.transferSteam(self.down)
        if self.pressure > 1 and self.left and Piece.RIGHT in self.left.accept:
            self.transferSteam(self.left)
