from pipedreams.gfx import loadImage

from piece import Piece

class LimitRight(Piece):
    def __init__(self):
        Piece.__init__(self)

        self.image = loadImage("limit_right.png")
        self.accept = [Piece.LEFT]
        self.pipe = True
        self.volume = 10
        self.rotate = LimitDown

    def update(self, time):
        Piece.update(self, time)
        if self.pressure > 1 and self.right and Piece.LEFT in self.right.accept:
            self.transferSteam(self.right)

class LimitDown(Piece):
    def __init__(self):
        Piece.__init__(self)

        self.image = loadImage("limit_down.png")
        self.accept = [Piece.UP]
        self.pipe = True
        self.volume = 10
        self.rotate = LimitLeft

    def update(self, time):
        Piece.update(self, time)
        if self.pressure > 1 and self.down and Piece.UP in self.down.accept:
            self.transferSteam(self.down)

class LimitLeft(Piece):
    def __init__(self):
        Piece.__init__(self)

        self.image = loadImage("limit_left.png")
        self.accept = [Piece.RIGHT]
        self.pipe = True
        self.volume = 10
        self.rotate = LimitUp

    def update(self, time):
        Piece.update(self, time)
        if self.pressure > 1 and self.left and Piece.RIGHT in self.left.accept:
            self.transferSteam(self.left)

class LimitUp(Piece):
    def __init__(self):
        Piece.__init__(self)

        self.image = loadImage("limit_up.png")
        self.accept = [Piece.LEFT]
        self.pipe = True
        self.volume = 10
        self.rotate = LimitRight

    def update(self, time):
        Piece.update(self, time)
        if self.pressure > 1 and self.up and Piece.DOWN in self.up.accept:
            self.transferSteam(self.up)
