from pipedreams.gfx import loadImage

from piece import Piece

limit = 30.0

class Red(Piece):
    def __init__(self):
        Piece.__init__(self)

        self.image = loadImage("red.png")
        self.accept = [Piece.RIGHT, Piece.LEFT]
        self.volume = 10
        self.rotate = Red

    def update(self, time):
        Piece.update(self, time)

        if self.O > 0:
            if self.O > 20:
                self.O = self.O - 20
                self.R = self.R + 20
            else:
                self.R = self.R + self.O
                self.O = 0

        if self.pressure > 1 and self.left and Piece.RIGHT in self.left.accept:
            self.transferSteam(self.left)
        if self.pressure > 1 and self.right and Piece.LEFT in self.right.accept:
            self.transferSteam(self.right)

class Green(Piece):
    def __init__(self):
        Piece.__init__(self)

        self.image = loadImage("green.png")
        self.accept = [Piece.RIGHT, Piece.LEFT]
        self.volume = 10
        self.rotate = Green

    def update(self, time):
        Piece.update(self, time)

        if self.O > 0:
            if self.O > 20:
                self.O = self.O - 20
                self.G = self.G + 20
            else:
                self.G = self.G + self.O
                self.O = 0

        if self.pressure > 1 and self.left and Piece.RIGHT in self.left.accept:
            self.transferSteam(self.left)
        if self.pressure > 1 and self.right and Piece.LEFT in self.right.accept:
            self.transferSteam(self.right)

class Blue(Piece):
    def __init__(self):
        Piece.__init__(self)

        self.image = loadImage("blue.png")
        self.accept = [Piece.RIGHT, Piece.LEFT]
        self.volume = 10
        self.rotate = Blue

    def update(self, time):
        Piece.update(self, time)

        if self.O > 0:
            if self.O > 10:
                self.O = self.O - 20
                self.B = self.B + 20
            else:
                self.B = self.B + self.O
                self.O = 0

        if self.pressure > 1 and self.left and Piece.RIGHT in self.left.accept:
            self.transferSteam(self.left)
        if self.pressure > 1 and self.right and Piece.LEFT in self.right.accept:
            self.transferSteam(self.right)

class Yellow(Piece):
    def __init__(self):
        Piece.__init__(self)

        self.image = loadImage("yellow.png")
        self.accept = [Piece.RIGHT, Piece.LEFT]
        self.volume = 10
        self.rotate = Yellow

    def update(self, time):
        Piece.update(self, time)

        if self.O > 0:
            if self.O > 20:
                self.O = self.O - 20
                self.Y = self.Y + 20
            else:
                self.Y = self.Y + self.O
                self.O = 0

        if self.pressure > 1 and self.left and Piece.RIGHT in self.left.accept:
            self.transferSteam(self.left)
        if self.pressure > 1 and self.right and Piece.LEFT in self.right.accept:
            self.transferSteam(self.right)
