from pipedreams.gfx import loadImage

from piece import Piece

class Horizontal(Piece):
    def __init__(self):
        Piece.__init__(self)

        self.image = loadImage("horizontal.png")
        self.accept = [Piece.LEFT, Piece.RIGHT]
        self.pipe = True
        self.volume = 10
        self.rotate = Vertical

    def update(self, time):
        Piece.update(self, time)
        if self.pressure > 1 and self.left and Piece.RIGHT in self.left.accept:
            self.transferSteam(self.left)
        if self.pressure > 1 and self.right and Piece.LEFT in self.right.accept:
            self.transferSteam(self.right)

class Vertical(Piece):
    def __init__(self):
        Piece.__init__(self)

        self.image = loadImage("vertical.png")
        self.accept = [Piece.UP, Piece.DOWN]
        self.pipe = True
        self.volume = 10
        self.rotate = Horizontal

    def update(self, time):
        Piece.update(self, time)
        if self.pressure > 1 and self.down and Piece.UP in self.down.accept:
            self.transferSteam(self.down)
        if self.pressure > 1 and self.up and Piece.DOWN in self.up.accept:
            self.transferSteam(self.up)
