from pipedreams.gfx import loadImage

from piece import Piece

class ThinHorizontal(Piece):
    def __init__(self):
        Piece.__init__(self)

        self.image = loadImage("thin_horizontal.png")
        self.accept = [Piece.LEFT, Piece.RIGHT]
        self.pipe = True
        self.volume = 2
        self.rotate = ThinVertical
        self.leakage = 0.1

    def update(self, time):
        Piece.update(self, time)
        if self.pressure > 1 and self.left and Piece.RIGHT in self.left.accept:
            self.transferSteam(self.left)
        if self.pressure > 1 and self.right and Piece.LEFT in self.right.accept:
            self.transferSteam(self.right)

class ThinVertical(Piece):
    def __init__(self):
        Piece.__init__(self)

        self.image = loadImage("thin_vertical.png")
        self.accept = [Piece.UP, Piece.DOWN]
        self.placed_graph = True
        self.volume = 2
        self.rotate = ThinHorizontal
        self.leakage = 0.1

    def update(self, time):
        Piece.update(self, time)
        if self.pressure > 1 and self.down and Piece.UP in self.down.accept:
            self.transferSteam(self.down)
        if self.pressure > 1 and self.up and Piece.DOWN in self.up.accept:
            self.transferSteam(self.up)
